import unittest
from modelverse_kernel.main import ModelverseKernel
from utils import execute_until_finished, MvSWrapper

class Testwhile(unittest.TestCase):
    def setUp(self):
        self.mvs = MvSWrapper()
        self.root = self.mvs.execute("RR", [])[0]
        self.mvk = ModelverseKernel(self.root)

    def test_while_evaluate_condition(self):
        root = self.root
        user_root = self.mvs.execute("CN", [])[0]
        user_frame = self.mvs.execute("CN", [])[0]
        phase = self.mvs.execute("CNV", ["init"])[0]
        inst = self.mvs.execute("CNV", [{"value":"while"}])[0]
        evalstack = self.mvs.execute("CN", [])[0]
        cond = self.mvs.execute("CN", [])[0]

        self.mvs.execute("CD", [root, "user_1", user_root])
        self.mvs.execute("CD", [user_root, "frame", user_frame])
        self.mvs.execute("CD", [user_frame, "phase", phase])
        self.mvs.execute("CD", [user_frame, "IP", inst])
        self.mvs.execute("CD", [inst, "cond", cond])
        self.mvs.execute("CD", [user_frame, "evalstack", evalstack])

        # Do the invocation until it returns None
        execute_until_finished(self.mvk, self.mvs)

        # Execution of the command finished, so the MvS should be in the correct new state right now
        self.assertEquals(self.mvs.execute("RD", [root, "user_1"])[0], user_root)
        self.assertEquals(self.mvs.execute("RD", [user_root, "frame"])[0], user_frame)
        self.assertEquals(self.mvs.execute("RV", [self.mvs.execute("RD", [user_frame, "phase"])[0]])[0], "init")
        self.assertEquals(self.mvs.execute("RD", [user_frame, "IP"])[0], cond)
        new_evalstack = self.mvs.execute("RD", [user_frame, "evalstack"])[0]
        self.assertNotEquals(evalstack, new_evalstack)
        self.assertEquals(self.mvs.execute("RD", [new_evalstack, "prev"])[0], evalstack)
        self.assertEquals(self.mvs.execute("RD", [evalstack, "inst"])[0], inst)
        self.assertEquals(self.mvs.execute("RV", [self.mvs.execute("RD", [evalstack, "phase"])[0]])[0], "cond")

    def test_while_true(self):
        root = self.root
        user_root = self.mvs.execute("CN", [])[0]
        user_frame = self.mvs.execute("CN", [])[0]
        phase = self.mvs.execute("CNV", ["cond"])[0]
        inst = self.mvs.execute("CNV", [{"value":"while"}])[0]
        evalstack = self.mvs.execute("CN", [])[0]
        body = self.mvs.execute("CN", [])[0]
        returnvalue = self.mvs.execute("CNV", [True])[0]

        self.mvs.execute("CD", [root, "user_1", user_root])
        self.mvs.execute("CD", [user_root, "frame", user_frame])
        self.mvs.execute("CD", [user_frame, "phase", phase])
        self.mvs.execute("CD", [user_frame, "IP", inst])
        self.mvs.execute("CD", [inst, "body", body])
        self.mvs.execute("CD", [user_frame, "evalstack", evalstack])
        self.mvs.execute("CD", [user_frame, "returnvalue", returnvalue])

        # Do the invocation until it returns None
        execute_until_finished(self.mvk, self.mvs)

        # Execution of the command finished, so the MvS should be in the correct new state right now
        self.assertEquals(self.mvs.execute("RD", [root, "user_1"])[0], user_root)
        self.assertEquals(self.mvs.execute("RD", [user_root, "frame"])[0], user_frame)
        self.assertEquals(self.mvs.execute("RV", [self.mvs.execute("RD", [user_frame, "phase"])[0]])[0], "init")
        self.assertEquals(self.mvs.execute("RD", [user_frame, "IP"])[0], body)
        new_evalstack = self.mvs.execute("RD", [user_frame, "evalstack"])[0]
        self.assertNotEquals(evalstack, new_evalstack)
        self.assertEquals(self.mvs.execute("RD", [new_evalstack, "prev"])[0], evalstack)
        self.assertEquals(self.mvs.execute("RD", [evalstack, "inst"])[0], inst)
        self.assertEquals(self.mvs.execute("RV", [self.mvs.execute("RD", [evalstack, "phase"])[0]])[0], "init")

    def test_while_false(self):
        root = self.root
        user_root = self.mvs.execute("CN", [])[0]
        user_frame = self.mvs.execute("CN", [])[0]
        phase = self.mvs.execute("CNV", ["cond"])[0]
        inst = self.mvs.execute("CNV", [{"value":"while"}])[0]
        returnvalue = self.mvs.execute("CNV", [False])[0]

        self.mvs.execute("CD", [root, "user_1", user_root])
        self.mvs.execute("CD", [user_root, "frame", user_frame])
        self.mvs.execute("CD", [user_frame, "phase", phase])
        self.mvs.execute("CD", [user_frame, "IP", inst])
        self.mvs.execute("CD", [user_frame, "returnvalue", returnvalue])

        # Do the invocation until it returns None
        execute_until_finished(self.mvk, self.mvs)

        # Execution of the command finished, so the MvS should be in the correct new state right now
        self.assertEquals(self.mvs.execute("RD", [root, "user_1"])[0], user_root)
        self.assertEquals(self.mvs.execute("RD", [user_root, "frame"])[0], user_frame)
        self.assertEquals(self.mvs.execute("RV", [self.mvs.execute("RD", [user_frame, "phase"])[0]])[0], "finish")
        self.assertEquals(self.mvs.execute("RD", [user_frame, "IP"])[0], inst)
